;ASPECTS OF BANDLIMITING
;Ex.10, FLTK example

<CsoundSynthesizer>
<CsOptions>

-+rtaudio=portaudio -odac 
csound -s -d -b4096 -B4096 

</CsOptions>
<CsInstruments>

sr	=	44100
kr	=	441
ksmps	=	100
nchnls	=	1



;*****************************************
;create an FLTK slider panel
;*****************************************
	FLcolor 151, 181, 210 
	FLpanel	"Bandlimiting Example",300,200

;kout, ihandle FLslider "label", imin, imax, iexp, itype, idisp, 
;iwidth, iheight, ix, iy

gk1, ih1 FLslider "Frequency", 0, 140, 0, 5, -1, 200, 20, 30, 40
gk2, ih2 FLslider "Timbre", 0, 140, 0, 5, -1, 200, 20, 30, 80
gk3, ih3 FLslider "Amplitude", 0, 10000, 0, 5, -1, 200, 20, 30, 120

	FLpanel_end
	FLsetVal_i	0, 	ih1
	FLsetVal_i	0, 	ih2
	FLsetVal_i	0, 	ih3
	FLrun


;*****************************************
; Create tables using ftgen
;*****************************************

/* Create a rich sawtooth wave */
i_	ftgen 30000, 0, 16384, 7, 1, 16384, -1

;find range for loop, below based on SR
;gives a midi pitch num for the high range
inum 	= sr/2
gimidi 	= 12 * (log(inum/220)/log(2))+57 ;convert freq to midi pitch
gimidi 	= round (gimidi)


/* generate bandlimited sawtooth waves for MIDI pitch nums */
i0	=  0
loop1:
imaxh	=  sr / (2 * 440.0 * exp (log(2.0) * (i0 - 69) / 12))
i_	ftgen i0, 0, 4096, -30, 30000, 1, imaxh
i0	=  i0 + 1
	if (i0 < gimidi - 0.5) igoto loop1


;  generate tables for reson filter bw parameter
;  one bw (in freq) per midi note for ea. table
;  lower tables nums have higher bandwidth
i2	=  0
loop2:
ibw	=   440.0 * exp (log(2.0) * (i2 - 69) / 12)
i_	ftgen (gimidi + 200)- i2, 0, 2, -16, ibw, 2, 0, ibw
itable =  (gimidi + 200) - i2
;print itable, ibw 
i2	=  i2 + 1
	if (i2 < gimidi - 0.5) igoto loop2

;===================================================
;===================================================
;===================================================
	instr 1

;slider values for TIMBRE
kfn = gk2
	if (kfn < 1) then
		kfn = 1
	endif
    	if (kfn > = gimidi) then
		kfn = gimidi - 1
    	endif
kfn = kfn + 200
;printk2 kfn, 5
kbw tablekt   2,  kfn, 0

;slider values for FREQUENCY
ktable = gk1
	if (ktable < 1) then
		ktable = 1
	endif
	if (ktable > = gimidi) then
		ktable = gimidi - 1
    	endif
;printk2 ktable, 5

;convert midi pitch nums to hertz
kcps	=  440.0 * exp (log(2.0) * (ktable - 69) / 12)

;add portamento for freqs
kcps    port  	kcps, 0.09 
a2	oscilikt gk3, kcps, ktable

kbw = round(kbw)
kbw    	port  kbw, 0.09
afilt 	resonx a2, kcps, kbw, 4 ;bw at k-rate
asig 	balance afilt, a2

out asig
	endin


;===================================================



</CsInstruments>
<CsScore>

; Play Instrument #1 

i1 0 60
e

</CsScore>
</CsoundSynthesizer>
